Index: uspace/lib/draw/font/pcf.c
===================================================================
--- uspace/lib/draw/font/pcf.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/draw/font/pcf.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -42,5 +42,4 @@
 #include <offset.h>
 #include <stdlib.h>
-#include <str.h>
 
 #include "pcf.h"
@@ -147,5 +146,5 @@
 }
 
-static errno_t pcf_resolve_glyph(void *opaque_data, const wchar_t chr,
+static int pcf_resolve_glyph(void *opaque_data, const wchar_t chr,
     glyph_id_t *glyph_id)
 {
@@ -184,5 +183,5 @@
 }
 
-static errno_t load_glyph_metrics(pcf_data_t *data, uint32_t glyph_id,
+static int load_glyph_metrics(pcf_data_t *data, uint32_t glyph_id,
     pcf_toc_entry_t *table, pcf_default_metrics_t *metrics)
 {
@@ -254,5 +253,5 @@
 }
 
-static errno_t pcf_load_glyph_surface(void *opaque_data, glyph_id_t glyph_id,
+static int pcf_load_glyph_surface(void *opaque_data, glyph_id_t glyph_id,
     surface_t **out_surface)
 {
@@ -261,5 +260,5 @@
 	pcf_default_metrics_t pcf_metrics;
 	memset(&pcf_metrics, 0, sizeof(pcf_default_metrics_t));
-	errno_t rc = load_glyph_metrics(data, glyph_id, &data->metrics_table,
+	int rc = load_glyph_metrics(data, glyph_id, &data->metrics_table,
 	    &pcf_metrics);
 	if (rc != EOK)
@@ -269,5 +268,6 @@
 	    (glyph_id * sizeof(uint32_t));
 	
-	if (fseek(data->file, offset, SEEK_SET) < 0)
+	rc = fseek(data->file, offset, SEEK_SET);
+	if (rc != 0)
 		return errno;
 	
@@ -284,5 +284,6 @@
 	    + bitmap_offset;
 	
-	if (fseek(data->file, offset, SEEK_SET) < 0)
+	rc = fseek(data->file, offset, SEEK_SET);
+	if (rc != 0)
 		return errno;
 	
@@ -340,5 +341,5 @@
 }
 
-static errno_t pcf_load_glyph_metrics(void *opaque_data, glyph_id_t glyph_id,
+static int pcf_load_glyph_metrics(void *opaque_data, glyph_id_t glyph_id,
     glyph_metrics_t *gm)
 {
@@ -347,5 +348,5 @@
 	pcf_default_metrics_t pcf_metrics;
 	memset(&pcf_metrics, 0, sizeof(pcf_default_metrics_t));
-	errno_t rc = load_glyph_metrics(data, glyph_id, &data->metrics_table,
+	int rc = load_glyph_metrics(data, glyph_id, &data->metrics_table,
 	    &pcf_metrics);
 	if (rc != EOK)
@@ -378,5 +379,5 @@
 };
 
-static errno_t pcf_read_toc(pcf_data_t *data)
+static int pcf_read_toc(pcf_data_t *data)
 {
 	int rc = fseek(data->file, 0, SEEK_END);
@@ -461,5 +462,5 @@
 }
 
-static errno_t pcf_seek_table_header(pcf_data_t *data, pcf_toc_entry_t *table)
+static int pcf_seek_table_header(pcf_data_t *data, pcf_toc_entry_t *table)
 {
 	uint32_t format;
@@ -479,7 +480,7 @@
 }
 
-static errno_t pcf_read_bitmap_table_header(pcf_data_t *data)
-{
-	errno_t rc = pcf_seek_table_header(data, &data->bitmap_table);
+static int pcf_read_bitmap_table_header(pcf_data_t *data)
+{
+	int rc = pcf_seek_table_header(data, &data->bitmap_table);
 	if (rc != EOK)
 		return rc;
@@ -499,7 +500,7 @@
 }
 
-static errno_t pcf_read_metrics_table_header(pcf_data_t *data)
-{
-	errno_t rc = pcf_seek_table_header(data, &data->metrics_table);
+static int pcf_read_metrics_table_header(pcf_data_t *data)
+{
+	int rc = pcf_seek_table_header(data, &data->metrics_table);
 	if (rc != EOK)
 		return rc;
@@ -532,7 +533,7 @@
 }
 
-static errno_t pcf_read_encodings_table_header(pcf_data_t *data)
-{
-	errno_t rc = pcf_seek_table_header(data, &data->encodings_table);
+static int pcf_read_encodings_table_header(pcf_data_t *data)
+{
+	int rc = pcf_seek_table_header(data, &data->encodings_table);
 	if (rc != EOK)
 		return rc;
@@ -559,7 +560,7 @@
 }
 
-static errno_t pcf_read_accelerators_table(pcf_data_t *data)
-{
-	errno_t rc = pcf_seek_table_header(data, &data->accelerators_table);
+static int pcf_read_accelerators_table(pcf_data_t *data)
+{
+	int rc = pcf_seek_table_header(data, &data->accelerators_table);
 	if (rc != EOK)
 		return rc;
@@ -580,7 +581,7 @@
 }
 
-errno_t pcf_font_create(font_t **font, char *filename, uint16_t points)
-{
-	errno_t rc;
+int pcf_font_create(font_t **font, char *filename, uint16_t points)
+{
+	int rc;
 	pcf_data_t *data = malloc(sizeof(pcf_data_t));
 	if (data == NULL)
Index: uspace/lib/draw/font/pcf.h
===================================================================
--- uspace/lib/draw/font/pcf.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/draw/font/pcf.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -39,5 +39,5 @@
 #include "../font.h"
 
-extern errno_t pcf_font_create(font_t **, char *path, uint16_t points);
+extern int pcf_font_create(font_t **, char *path, uint16_t points);
 
 #endif
Index: uspace/lib/drv/generic/driver.c
===================================================================
--- uspace/lib/drv/generic/driver.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/drv/generic/driver.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -124,5 +124,5 @@
 	
 	char *dev_name = NULL;
-	errno_t rc = async_data_write_accept((void **) &dev_name, true, 0, 0, 0, 0);
+	int rc = async_data_write_accept((void **) &dev_name, true, 0, 0, 0, 0);
 	if (rc != EOK) {
 		async_answer_0(iid, rc);
@@ -157,5 +157,5 @@
 	(void) parent_fun_handle;
 	
-	errno_t res = driver->driver_ops->dev_add(dev);
+	int res = driver->driver_ops->dev_add(dev);
 	
 	if (res != EOK) {
@@ -189,5 +189,5 @@
 	}
 	
-	errno_t rc;
+	int rc;
 	
 	if (driver->driver_ops->dev_remove != NULL)
@@ -196,13 +196,8 @@
 		rc = ENOTSUP;
 	
-	if (rc == EOK) {
-		fibril_mutex_lock(&devices_mutex);
-		list_remove(&dev->link);
-		fibril_mutex_unlock(&devices_mutex);
+	if (rc == EOK)
 		dev_del_ref(dev);
-	}
-	
-	dev_del_ref(dev);
-	async_answer_0(iid, rc);
+	
+	async_answer_0(iid, (sysarg_t) rc);
 }
 
@@ -222,5 +217,5 @@
 	}
 	
-	errno_t rc;
+	int rc;
 	
 	if (driver->driver_ops->dev_gone != NULL)
@@ -229,13 +224,8 @@
 		rc = ENOTSUP;
 	
-	if (rc == EOK) {
-		fibril_mutex_lock(&devices_mutex);
-		list_remove(&dev->link);
-		fibril_mutex_unlock(&devices_mutex);
+	if (rc == EOK)
 		dev_del_ref(dev);
-	}
-	
-	dev_del_ref(dev);
-	async_answer_0(iid, rc);
+	
+	async_answer_0(iid, (sysarg_t) rc);
 }
 
@@ -263,5 +253,5 @@
 	
 	/* Call driver entry point */
-	errno_t rc;
+	int rc;
 	
 	if (driver->driver_ops->fun_online != NULL)
@@ -272,5 +262,5 @@
 	fun_del_ref(fun);
 	
-	async_answer_0(iid, rc);
+	async_answer_0(iid, (sysarg_t) rc);
 }
 
@@ -298,5 +288,5 @@
 	
 	/* Call driver entry point */
-	errno_t rc;
+	int rc;
 	
 	if (driver->driver_ops->fun_offline != NULL)
@@ -305,5 +295,5 @@
 		rc = ENOTSUP;
 	
-	async_answer_0(iid, rc);
+	async_answer_0(iid, (sysarg_t) rc);
 }
 
@@ -414,5 +404,5 @@
 	 */
 	
-	errno_t ret = EOK;
+	int ret = EOK;
 	/* Open device function */
 	if (fun->ops != NULL && fun->ops->open != NULL)
@@ -676,5 +666,5 @@
  * @return	EOK on success, ENOMEM if out of memory
  */
-errno_t ddf_fun_set_name(ddf_fun_t *dev, const char *name)
+int ddf_fun_set_name(ddf_fun_t *dev, const char *name)
 {
 	assert(dev->name == NULL);
@@ -822,8 +812,8 @@
  * @param fun Function to bind
  *
- * @return EOK on success or an error code
- *
- */
-errno_t ddf_fun_bind(ddf_fun_t *fun)
+ * @return EOK on success or negative error code
+ *
+ */
+int ddf_fun_bind(ddf_fun_t *fun)
 {
 	assert(fun->bound == false);
@@ -832,5 +822,5 @@
 	
 	add_to_functions_list(fun);
-	errno_t res = devman_add_function(fun->name, fun->ftype, &fun->match_ids,
+	int res = devman_add_function(fun->name, fun->ftype, &fun->match_ids,
 	    fun->dev->handle, &fun->handle);
 	if (res != EOK) {
@@ -850,12 +840,12 @@
  * @param fun Function to unbind
  *
- * @return EOK on success or an error code
- *
- */
-errno_t ddf_fun_unbind(ddf_fun_t *fun)
+ * @return EOK on success or negative error code
+ *
+ */
+int ddf_fun_unbind(ddf_fun_t *fun)
 {
 	assert(fun->bound == true);
 	
-	errno_t res = devman_remove_function(fun->handle);
+	int res = devman_remove_function(fun->handle);
 	if (res != EOK)
 		return res;
@@ -871,12 +861,12 @@
  * @param fun Function to online
  *
- * @return EOK on success or an error code
- *
- */
-errno_t ddf_fun_online(ddf_fun_t *fun)
+ * @return EOK on success or negative error code
+ *
+ */
+int ddf_fun_online(ddf_fun_t *fun)
 {
 	assert(fun->bound == true);
 	
-	errno_t res = devman_drv_fun_online(fun->handle);
+	int res = devman_drv_fun_online(fun->handle);
 	if (res != EOK)
 		return res;
@@ -889,12 +879,12 @@
  * @param fun Function to offline
  *
- * @return EOK on success or an error code
- *
- */
-errno_t ddf_fun_offline(ddf_fun_t *fun)
+ * @return EOK on success or negative error code
+ *
+ */
+int ddf_fun_offline(ddf_fun_t *fun)
 {
 	assert(fun->bound == true);
 	
-	errno_t res = devman_drv_fun_offline(fun->handle);
+	int res = devman_drv_fun_offline(fun->handle);
 	if (res != EOK)
 		return res;
@@ -916,5 +906,5 @@
  *
  */
-errno_t ddf_fun_add_match_id(ddf_fun_t *fun, const char *match_id_str,
+int ddf_fun_add_match_id(ddf_fun_t *fun, const char *match_id_str,
     int match_score)
 {
@@ -963,5 +953,5 @@
  *
  */
-errno_t ddf_fun_add_to_category(ddf_fun_t *fun, const char *cat_name)
+int ddf_fun_add_to_category(ddf_fun_t *fun, const char *cat_name)
 {
 	assert(fun->bound == true);
@@ -984,5 +974,5 @@
 	 */
 	port_id_t port;
-	errno_t rc = async_create_port(INTERFACE_DDF_DRIVER, driver_connection_driver,
+	int rc = async_create_port(INTERFACE_DDF_DRIVER, driver_connection_driver,
 	    NULL, &port);
 	if (rc != EOK) {
Index: uspace/lib/drv/generic/interrupt.c
===================================================================
--- uspace/lib/drv/generic/interrupt.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/drv/generic/interrupt.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -43,13 +43,12 @@
 #include "private/driver.h"
 
-errno_t register_interrupt_handler(ddf_dev_t *dev, int irq,
-    interrupt_handler_t *handler, const irq_code_t *irq_code,
-    cap_handle_t *handle)
+int register_interrupt_handler(ddf_dev_t *dev, int irq,
+    interrupt_handler_t *handler, const irq_code_t *irq_code)
 {
 	return async_irq_subscribe(irq, (async_notification_handler_t) handler,
-	    dev, irq_code, handle);
+	    dev, irq_code);
 }
 
-errno_t unregister_interrupt_handler(ddf_dev_t *dev, cap_handle_t cap)
+int unregister_interrupt_handler(ddf_dev_t *dev, int cap)
 {
 	return async_irq_unsubscribe(cap);
Index: uspace/lib/drv/generic/log.c
===================================================================
--- uspace/lib/drv/generic/log.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/drv/generic/log.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -40,5 +40,5 @@
  *
  */
-errno_t ddf_log_init(const char *drv_name)
+int ddf_log_init(const char *drv_name)
 {
 	return log_init(drv_name);
Index: uspace/lib/drv/generic/logbuf.c
===================================================================
--- uspace/lib/drv/generic/logbuf.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/drv/generic/logbuf.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -35,5 +35,4 @@
 #include <ddf/log.h>
 #include <assert.h>
-#include <str.h>
 
 /** Formatting string for printing number of not-printed items. */
Index: uspace/lib/drv/generic/private/driver.h
===================================================================
--- uspace/lib/drv/generic/private/driver.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/drv/generic/private/driver.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -57,5 +57,5 @@
 	
 	/** Device name */
-	char *name;
+	const char *name;
 	
 	/** Driver-specific data associated with this device */
@@ -84,5 +84,5 @@
 	
 	/** Function name */
-	char *name;
+	const char *name;
 	
 	/** List of device ids for driver matching */
Index: uspace/lib/drv/generic/remote_ahci.c
===================================================================
--- uspace/lib/drv/generic/remote_ahci.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/drv/generic/remote_ahci.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -39,5 +39,4 @@
 #include <stdio.h>
 #include <macros.h>
-#include <str.h>
 #include "ahci_iface.h"
 #include "ddf/driver.h"
@@ -66,5 +65,5 @@
 	
 	char devn[MAX_NAME_LENGTH];
-	errno_t rc = devman_fun_get_name(funh, devn, MAX_NAME_LENGTH);
+	int rc = devman_fun_get_name(funh, devn, MAX_NAME_LENGTH);
 	if (rc != EOK)
 		return NULL;
@@ -84,5 +83,5 @@
 }
 
-errno_t ahci_get_sata_device_name(async_sess_t *sess, size_t sata_dev_name_length,
+int ahci_get_sata_device_name(async_sess_t *sess, size_t sata_dev_name_length,
     char *sata_dev_name)
 {
@@ -96,5 +95,5 @@
 	async_data_read_start(exch, sata_dev_name, sata_dev_name_length);
 	
-	errno_t rc;
+	sysarg_t rc;
 	async_wait_for(req, &rc);
 	
@@ -102,5 +101,5 @@
 }
 
-errno_t ahci_get_num_blocks(async_sess_t *sess, uint64_t *blocks)
+int ahci_get_num_blocks(async_sess_t *sess, uint64_t *blocks)
 {
 	async_exch_t *exch = async_exchange_begin(sess);
@@ -110,5 +109,5 @@
 	sysarg_t blocks_hi;
 	sysarg_t blocks_lo;
-	errno_t rc = async_req_1_2(exch, DEV_IFACE_ID(AHCI_DEV_IFACE),
+	int rc = async_req_1_2(exch, DEV_IFACE_ID(AHCI_DEV_IFACE),
 	    IPC_M_AHCI_GET_NUM_BLOCKS, &blocks_hi, &blocks_lo);
 	
@@ -123,5 +122,5 @@
 }
 
-errno_t ahci_get_block_size(async_sess_t *sess, size_t *blocks_size)
+int ahci_get_block_size(async_sess_t *sess, size_t *blocks_size)
 {
 	async_exch_t *exch = async_exchange_begin(sess);
@@ -130,5 +129,5 @@
 	
 	sysarg_t bs;
-	errno_t rc = async_req_1_1(exch, DEV_IFACE_ID(AHCI_DEV_IFACE),
+	int rc = async_req_1_1(exch, DEV_IFACE_ID(AHCI_DEV_IFACE),
 	    IPC_M_AHCI_GET_BLOCK_SIZE, &bs);
 	
@@ -141,5 +140,5 @@
 }
 
-errno_t ahci_read_blocks(async_sess_t *sess, uint64_t blocknum, size_t count,
+int ahci_read_blocks(async_sess_t *sess, uint64_t blocknum, size_t count,
     void *buf)
 {
@@ -156,5 +155,5 @@
 	async_exchange_end(exch);
 	
-	errno_t rc;
+	sysarg_t rc;
 	async_wait_for(req, &rc);
 	
@@ -162,5 +161,5 @@
 }
 
-errno_t ahci_write_blocks(async_sess_t *sess, uint64_t blocknum, size_t count,
+int ahci_write_blocks(async_sess_t *sess, uint64_t blocknum, size_t count,
     void* buf)
 {
@@ -176,5 +175,5 @@
 	async_exchange_end(exch);
 	
-	errno_t rc;
+	sysarg_t rc;
 	async_wait_for(req, &rc);
 	
@@ -228,5 +227,5 @@
 	}	
 	
-	const errno_t ret = ahci_iface->get_sata_device_name(fun,
+	const int ret = ahci_iface->get_sata_device_name(fun,
 	    sata_dev_name_length, sata_dev_name);
 	
@@ -252,5 +251,5 @@
 	
 	uint64_t blocks;
-	const errno_t ret = ahci_iface->get_num_blocks(fun, &blocks);
+	const int ret = ahci_iface->get_num_blocks(fun, &blocks);
 	
 	if (ret != EOK)
@@ -271,5 +270,5 @@
 	
 	size_t blocks;
-	const errno_t ret = ahci_iface->get_block_size(fun, &blocks);
+	const int ret = ahci_iface->get_block_size(fun, &blocks);
 	
 	if (ret != EOK)
@@ -303,5 +302,5 @@
 	const size_t cnt = (size_t) DEV_IPC_GET_ARG3(*call);
 	
-	const errno_t ret = ahci_iface->read_blocks(fun, blocknum, cnt, buf);
+	const int ret = ahci_iface->read_blocks(fun, blocknum, cnt, buf);
 	
 	async_answer_0(callid, ret);
@@ -332,5 +331,5 @@
 	const size_t cnt = (size_t) DEV_IPC_GET_ARG3(*call);
 	
-	const errno_t ret = ahci_iface->write_blocks(fun, blocknum, cnt, buf);
+	const int ret = ahci_iface->write_blocks(fun, blocknum, cnt, buf);
 	
 	async_answer_0(callid, ret);
Index: uspace/lib/drv/generic/remote_audio_mixer.c
===================================================================
--- uspace/lib/drv/generic/remote_audio_mixer.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/drv/generic/remote_audio_mixer.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -94,10 +94,10 @@
  * @return Error code.
  */
-errno_t audio_mixer_get_info(async_exch_t *exch, char **name, unsigned *items)
+int audio_mixer_get_info(async_exch_t *exch, const char **name, unsigned *items)
 {
 	if (!exch)
 		return EINVAL;
 	sysarg_t name_size, itemc;
-	const errno_t ret = async_req_1_2(exch, DEV_IFACE_ID(AUDIO_MIXER_IFACE),
+	const int ret = async_req_1_2(exch, DEV_IFACE_ID(AUDIO_MIXER_IFACE),
 	    IPC_M_AUDIO_MIXER_GET_INFO, &name_size, &itemc);
 	if (ret == EOK && name) {
@@ -109,5 +109,5 @@
 			return ENOMEM;
 		}
-		const errno_t ret =
+		const int ret =
 		    async_data_read_start(exch, name_place, name_size);
 		if (ret != EOK) {
@@ -130,11 +130,11 @@
  * @return Error code.
  */
-errno_t audio_mixer_get_item_info(async_exch_t *exch, unsigned item,
-    char **name, unsigned *levels)
+int audio_mixer_get_item_info(async_exch_t *exch, unsigned item,
+    const char **name, unsigned *levels)
 {
 	if (!exch)
 		return EINVAL;
 	sysarg_t name_size, lvls;
-	const errno_t ret = async_req_2_2(exch, DEV_IFACE_ID(AUDIO_MIXER_IFACE),
+	const int ret = async_req_2_2(exch, DEV_IFACE_ID(AUDIO_MIXER_IFACE),
 	    IPC_M_AUDIO_MIXER_GET_ITEM_INFO, item, &name_size, &lvls);
 	if (ret == EOK && name) {
@@ -146,5 +146,5 @@
 			return ENOMEM;
 		}
-		const errno_t ret =
+		const int ret =
 		    async_data_read_start(exch, name_place, name_size);
 		if (ret != EOK) {
@@ -166,5 +166,5 @@
  * @return Error code.
  */
-errno_t audio_mixer_set_item_level(async_exch_t *exch, unsigned item,
+int audio_mixer_set_item_level(async_exch_t *exch, unsigned item,
     unsigned level)
 {
@@ -183,5 +183,5 @@
  * @return Error code.
  */
-errno_t audio_mixer_get_item_level(async_exch_t *exch, unsigned item,
+int audio_mixer_get_item_level(async_exch_t *exch, unsigned item,
     unsigned *level)
 {
@@ -189,5 +189,5 @@
 		return EINVAL;
 	sysarg_t current;
-	const errno_t ret = async_req_2_1(exch, DEV_IFACE_ID(AUDIO_MIXER_IFACE),
+	const int ret = async_req_2_1(exch, DEV_IFACE_ID(AUDIO_MIXER_IFACE),
 	    IPC_M_AUDIO_MIXER_GET_ITEM_LEVEL, item, &current);
 	if (ret == EOK && level)
@@ -229,5 +229,5 @@
 	const char *name = NULL;
 	unsigned items = 0;
-	const errno_t ret = mixer_iface->get_info(fun, &name, &items);
+	const int ret = mixer_iface->get_info(fun, &name, &items);
 	const size_t name_size = name ? str_size(name) + 1 : 0;
 	async_answer_2(callid, ret, name_size, items);
@@ -261,5 +261,5 @@
 	const char *name = NULL;
 	unsigned values = 0;
-	const errno_t ret = mixer_iface->get_item_info(fun, item, &name, &values);
+	const int ret = mixer_iface->get_item_info(fun, item, &name, &values);
 	const size_t name_size = name ? str_size(name) + 1 : 0;
 	async_answer_2(callid, ret, name_size, values);
@@ -291,5 +291,5 @@
 	const unsigned item = DEV_IPC_GET_ARG1(*call);
 	const unsigned value = DEV_IPC_GET_ARG2(*call);
-	const errno_t ret = mixer_iface->set_item_level(fun, item, value);
+	const int ret = mixer_iface->set_item_level(fun, item, value);
 	async_answer_0(callid, ret);
 }
@@ -306,5 +306,5 @@
 	const unsigned item = DEV_IPC_GET_ARG1(*call);
 	unsigned current = 0;
-	const errno_t ret =
+	const int ret =
 	    mixer_iface->get_item_level(fun, item, &current);
 	async_answer_1(callid, ret, current);
Index: uspace/lib/drv/generic/remote_audio_pcm.c
===================================================================
--- uspace/lib/drv/generic/remote_audio_pcm.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/drv/generic/remote_audio_pcm.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -114,5 +114,5 @@
 	static category_id_t pcm_id = 0;
 	if (!resolved) {
-		const errno_t ret = loc_category_get_id("audio-pcm", &pcm_id,
+		const int ret = loc_category_get_id("audio-pcm", &pcm_id,
 		    IPC_FLAG_BLOCKING);
 		if (ret != EOK)
@@ -123,5 +123,5 @@
 	service_id_t *svcs = NULL;
 	size_t count = 0;
-	const errno_t ret = loc_category_get_svcs(pcm_id, &svcs, &count);
+	const int ret = loc_category_get_svcs(pcm_id, &svcs, &count);
 	if (ret != EOK)
 		return NULL;
@@ -143,5 +143,5 @@
 {
 	devman_handle_t device_handle = 0;
-	const errno_t ret = devman_fun_get_handle(name, &device_handle, 0);
+	const int ret = devman_fun_get_handle(name, &device_handle, 0);
 	if (ret != EOK)
 		return NULL;
@@ -184,5 +184,5 @@
  * @note Caller is responsible for freeing newly allocated memory.
  */
-errno_t audio_pcm_get_info_str(audio_pcm_sess_t *sess, char **name)
+int audio_pcm_get_info_str(audio_pcm_sess_t *sess, const char **name)
 {
 	if (!name)
@@ -190,5 +190,5 @@
 	async_exch_t *exch = async_exchange_begin(sess);
 	sysarg_t name_size;
-	const errno_t ret = async_req_1_1(exch,
+	const int ret = async_req_1_1(exch,
 	    DEV_IFACE_ID(AUDIO_PCM_BUFFER_IFACE),
 	    IPC_M_AUDIO_PCM_GET_INFO_STR, &name_size);
@@ -202,5 +202,5 @@
 			return ENOMEM;
 		}
-		const errno_t ret =
+		const int ret =
 		    async_data_read_start(exch, name_place, name_size);
 		if (ret != EOK) {
@@ -221,15 +221,18 @@
  * @param sess Audio device session.
  * @param cap  Audio device capability.
- * @param[out] val  Place to store queried value.
- *
- * @return Error code.
- */
-errno_t audio_pcm_query_cap(audio_pcm_sess_t *sess, audio_cap_t cap, sysarg_t *value)
-{
-	async_exch_t *exch = async_exchange_begin(sess);
-	const errno_t ret = async_req_2_1(exch,
+ * @param val  Place to store queried value.
+ *
+ * @return Error code.
+ */
+int audio_pcm_query_cap(audio_pcm_sess_t *sess, audio_cap_t cap)
+{
+	async_exch_t *exch = async_exchange_begin(sess);
+	sysarg_t value = 0;
+	const int ret = async_req_2_1(exch,
 	    DEV_IFACE_ID(AUDIO_PCM_BUFFER_IFACE), IPC_M_AUDIO_PCM_QUERY_CAPS,
-	    cap, value);
-	async_exchange_end(exch);
+	    cap, &value);
+	async_exchange_end(exch);
+	if (ret == EOK)
+		return value;
 	return ret;
 }
@@ -245,5 +248,5 @@
  * Works for both playback and capture.
  */
-errno_t audio_pcm_get_buffer_pos(audio_pcm_sess_t *sess, size_t *pos)
+int audio_pcm_get_buffer_pos(audio_pcm_sess_t *sess, size_t *pos)
 {
 	if (!pos)
@@ -251,5 +254,5 @@
 	async_exch_t *exch = async_exchange_begin(sess);
 	sysarg_t value = 0;
-	const errno_t ret = async_req_1_1(exch,
+	const int ret = async_req_1_1(exch,
 	    DEV_IFACE_ID(AUDIO_PCM_BUFFER_IFACE),
 	    IPC_M_AUDIO_PCM_GET_BUFFER_POS, &value);
@@ -273,5 +276,5 @@
  * parameters to the nearest values supported by the device.
  */
-errno_t audio_pcm_test_format(audio_pcm_sess_t *sess, unsigned *channels,
+int audio_pcm_test_format(audio_pcm_sess_t *sess, unsigned *channels,
     unsigned *rate, pcm_sample_format_t *format)
 {
@@ -280,5 +283,5 @@
 	sysarg_t rate_arg = rate ? *rate : 0;
 	sysarg_t format_arg = format ? *format : 0;
-	const errno_t ret = async_req_4_3(exch,
+	const int ret = async_req_4_3(exch,
 	    DEV_IFACE_ID(AUDIO_PCM_BUFFER_IFACE),
 	    IPC_M_AUDIO_PCM_TEST_FORMAT, channels_arg, rate_arg, format_arg,
@@ -311,5 +314,5 @@
  * @return Error code.
  */
-errno_t audio_pcm_register_event_callback(audio_pcm_sess_t *sess,
+int audio_pcm_register_event_callback(audio_pcm_sess_t *sess,
     async_port_handler_t event_callback, void *arg)
 {
@@ -319,5 +322,5 @@
 	async_exch_t *exch = async_exchange_begin(sess);
 	
-	errno_t ret = async_req_1_0(exch, DEV_IFACE_ID(AUDIO_PCM_BUFFER_IFACE),
+	int ret = async_req_1_0(exch, DEV_IFACE_ID(AUDIO_PCM_BUFFER_IFACE),
 	    IPC_M_AUDIO_PCM_REGISTER_EVENTS);
 	if (ret == EOK) {
@@ -338,8 +341,8 @@
  * @return Error code.
  */
-errno_t audio_pcm_unregister_event_callback(audio_pcm_sess_t *sess)
-{
-	async_exch_t *exch = async_exchange_begin(sess);
-	const errno_t ret = async_req_1_0(exch,
+int audio_pcm_unregister_event_callback(audio_pcm_sess_t *sess)
+{
+	async_exch_t *exch = async_exchange_begin(sess);
+	const int ret = async_req_1_0(exch,
 	    DEV_IFACE_ID(AUDIO_PCM_BUFFER_IFACE),
 	    IPC_M_AUDIO_PCM_UNREGISTER_EVENTS);
@@ -357,5 +360,5 @@
  * @return Error code.
  */
-errno_t audio_pcm_get_buffer(audio_pcm_sess_t *sess, void **buffer, size_t *size)
+int audio_pcm_get_buffer(audio_pcm_sess_t *sess, void **buffer, size_t *size)
 {
 	if (!buffer || !size)
@@ -365,5 +368,5 @@
 
 	sysarg_t buffer_size = *size;
-	errno_t ret = async_req_2_1(exch, DEV_IFACE_ID(AUDIO_PCM_BUFFER_IFACE),
+	int ret = async_req_2_1(exch, DEV_IFACE_ID(AUDIO_PCM_BUFFER_IFACE),
 	    IPC_M_AUDIO_PCM_GET_BUFFER, (sysarg_t)buffer_size, &buffer_size);
 	if (ret == EOK) {
@@ -388,8 +391,8 @@
  * @return Error code.
  */
-errno_t audio_pcm_release_buffer(audio_pcm_sess_t *sess)
-{
-	async_exch_t *exch = async_exchange_begin(sess);
-	const errno_t ret = async_req_1_0(exch,
+int audio_pcm_release_buffer(audio_pcm_sess_t *sess)
+{
+	async_exch_t *exch = async_exchange_begin(sess);
+	const int ret = async_req_1_0(exch,
 	    DEV_IFACE_ID(AUDIO_PCM_BUFFER_IFACE),
 	    IPC_M_AUDIO_PCM_RELEASE_BUFFER);
@@ -412,5 +415,5 @@
  * 0 to turn off event generation.
  */
-errno_t audio_pcm_start_playback_fragment(audio_pcm_sess_t *sess, unsigned frames,
+int audio_pcm_start_playback_fragment(audio_pcm_sess_t *sess, unsigned frames,
     unsigned channels, unsigned sample_rate, pcm_sample_format_t format)
 {
@@ -420,5 +423,5 @@
 	const sysarg_t packed = (channels << 16) | (format & UINT16_MAX);
 	async_exch_t *exch = async_exchange_begin(sess);
-	const errno_t ret = async_req_4_0(exch,
+	const int ret = async_req_4_0(exch,
 	    DEV_IFACE_ID(AUDIO_PCM_BUFFER_IFACE),
 	    IPC_M_AUDIO_PCM_START_PLAYBACK,
@@ -434,8 +437,8 @@
  * @return Error code.
  */
-errno_t audio_pcm_last_playback_fragment(audio_pcm_sess_t *sess)
-{
-	async_exch_t *exch = async_exchange_begin(sess);
-	const errno_t ret = async_req_2_0(exch,
+int audio_pcm_last_playback_fragment(audio_pcm_sess_t *sess)
+{
+	async_exch_t *exch = async_exchange_begin(sess);
+	const int ret = async_req_2_0(exch,
 	    DEV_IFACE_ID(AUDIO_PCM_BUFFER_IFACE),
 	    IPC_M_AUDIO_PCM_STOP_PLAYBACK, false);
@@ -454,5 +457,5 @@
  * @return Error code.
  */
-errno_t audio_pcm_start_playback(audio_pcm_sess_t *sess,
+int audio_pcm_start_playback(audio_pcm_sess_t *sess,
     unsigned channels, unsigned sample_rate, pcm_sample_format_t format)
 {
@@ -468,8 +471,8 @@
  * @return Error code.
  */
-errno_t audio_pcm_stop_playback_immediate(audio_pcm_sess_t *sess)
-{
-	async_exch_t *exch = async_exchange_begin(sess);
-	const errno_t ret = async_req_2_0(exch,
+int audio_pcm_stop_playback_immediate(audio_pcm_sess_t *sess)
+{
+	async_exch_t *exch = async_exchange_begin(sess);
+	const int ret = async_req_2_0(exch,
 	    DEV_IFACE_ID(AUDIO_PCM_BUFFER_IFACE),
 	    IPC_M_AUDIO_PCM_STOP_PLAYBACK, true);
@@ -485,8 +488,8 @@
  * @return Error code.
  */
-errno_t audio_pcm_stop_playback(audio_pcm_sess_t *sess)
-{
-	async_exch_t *exch = async_exchange_begin(sess);
-	const errno_t ret = async_req_2_0(exch,
+int audio_pcm_stop_playback(audio_pcm_sess_t *sess)
+{
+	async_exch_t *exch = async_exchange_begin(sess);
+	const int ret = async_req_2_0(exch,
 	    DEV_IFACE_ID(AUDIO_PCM_BUFFER_IFACE),
 	    IPC_M_AUDIO_PCM_STOP_PLAYBACK, false);
@@ -509,5 +512,5 @@
  * 0 to turn off event generation.
  */
-errno_t audio_pcm_start_capture_fragment(audio_pcm_sess_t *sess, unsigned frames,
+int audio_pcm_start_capture_fragment(audio_pcm_sess_t *sess, unsigned frames,
     unsigned channels, unsigned sample_rate, pcm_sample_format_t format)
 {
@@ -517,5 +520,5 @@
 	const sysarg_t packed = (channels << 16) | (format & UINT16_MAX);
 	async_exch_t *exch = async_exchange_begin(sess);
-	const errno_t ret = async_req_4_0(exch,
+	const int ret = async_req_4_0(exch,
 	    DEV_IFACE_ID(AUDIO_PCM_BUFFER_IFACE), IPC_M_AUDIO_PCM_START_CAPTURE,
 	    frames, sample_rate, packed);
@@ -534,5 +537,5 @@
  * @return Error code.
  */
-errno_t audio_pcm_start_capture(audio_pcm_sess_t *sess,
+int audio_pcm_start_capture(audio_pcm_sess_t *sess,
     unsigned channels, unsigned sample_rate, pcm_sample_format_t format)
 {
@@ -549,8 +552,8 @@
  * @return Error code.
  */
-errno_t audio_pcm_last_capture_fragment(audio_pcm_sess_t *sess)
-{
-	async_exch_t *exch = async_exchange_begin(sess);
-	const errno_t ret = async_req_2_0(exch,
+int audio_pcm_last_capture_fragment(audio_pcm_sess_t *sess)
+{
+	async_exch_t *exch = async_exchange_begin(sess);
+	const int ret = async_req_2_0(exch,
 	    DEV_IFACE_ID(AUDIO_PCM_BUFFER_IFACE),
 	    IPC_M_AUDIO_PCM_STOP_CAPTURE, false);
@@ -566,8 +569,8 @@
  * @return Error code.
  */
-errno_t audio_pcm_stop_capture_immediate(audio_pcm_sess_t *sess)
-{
-	async_exch_t *exch = async_exchange_begin(sess);
-	const errno_t ret = async_req_2_0(exch,
+int audio_pcm_stop_capture_immediate(audio_pcm_sess_t *sess)
+{
+	async_exch_t *exch = async_exchange_begin(sess);
+	const int ret = async_req_2_0(exch,
 	    DEV_IFACE_ID(AUDIO_PCM_BUFFER_IFACE),
 	    IPC_M_AUDIO_PCM_STOP_CAPTURE, true);
@@ -583,8 +586,8 @@
  * @return Error code.
  */
-errno_t audio_pcm_stop_capture(audio_pcm_sess_t *sess)
-{
-	async_exch_t *exch = async_exchange_begin(sess);
-	const errno_t ret = async_req_2_0(exch,
+int audio_pcm_stop_capture(audio_pcm_sess_t *sess)
+{
+	async_exch_t *exch = async_exchange_begin(sess);
+	const int ret = async_req_2_0(exch,
 	    DEV_IFACE_ID(AUDIO_PCM_BUFFER_IFACE),
 	    IPC_M_AUDIO_PCM_STOP_CAPTURE, false);
@@ -641,5 +644,5 @@
 	}
 	const char *name = NULL;
-	const errno_t ret = pcm_iface->get_info_str(fun, &name);
+	const int ret = pcm_iface->get_info_str(fun, &name);
 	const size_t name_size = name ? str_size(name) + 1 : 0;
 	async_answer_1(callid, ret, name_size);
@@ -692,5 +695,5 @@
 		return;
 	}
-	const errno_t ret = pcm_iface->set_event_session(fun, sess);
+	const int ret = pcm_iface->set_event_session(fun, sess);
 	if (ret != EOK) {
 		ddf_msg(LVL_DEBUG, "Failed to set event callback.");
@@ -722,5 +725,5 @@
 	const audio_pcm_iface_t *pcm_iface = iface;
 	size_t pos = 0;
-	const errno_t ret = pcm_iface->get_buffer_pos ?
+	const int ret = pcm_iface->get_buffer_pos ?
 	    pcm_iface->get_buffer_pos(fun, &pos) : ENOTSUP;
 	async_answer_1(callid, ret, pos);
@@ -733,5 +736,5 @@
 	unsigned rate = DEV_IPC_GET_ARG2(*call);
 	pcm_sample_format_t format = DEV_IPC_GET_ARG3(*call);
-	const errno_t ret = pcm_iface->test_format ?
+	const int ret = pcm_iface->test_format ?
 	    pcm_iface->test_format(fun, &channels, &rate, &format) : ENOTSUP;
 	async_answer_3(callid, ret, channels, rate, format);
@@ -750,5 +753,5 @@
 	void *buffer = NULL;
 	size_t size = DEV_IPC_GET_ARG1(*call);
-	errno_t ret = pcm_iface->get_buffer(fun, &buffer, &size);
+	int ret = pcm_iface->get_buffer(fun, &buffer, &size);
 	async_answer_1(callid, ret, size);
 	if (ret != EOK || size == 0)
@@ -792,5 +795,5 @@
 	const audio_pcm_iface_t *pcm_iface = iface;
 
-	const errno_t ret = pcm_iface->release_buffer ?
+	const int ret = pcm_iface->release_buffer ?
 	    pcm_iface->release_buffer(fun) : ENOTSUP;
 	async_answer_0(callid, ret);
@@ -807,5 +810,5 @@
 	const pcm_sample_format_t format = DEV_IPC_GET_ARG3(*call) & UINT16_MAX;
 
-	const errno_t ret = pcm_iface->start_playback
+	const int ret = pcm_iface->start_playback
 	    ? pcm_iface->start_playback(fun, frames, channels, rate, format)
 	    : ENOTSUP;
@@ -819,5 +822,5 @@
 	const bool immediate = DEV_IPC_GET_ARG1(*call);
 
-	const errno_t ret = pcm_iface->stop_playback ?
+	const int ret = pcm_iface->stop_playback ?
 	    pcm_iface->stop_playback(fun, immediate) : ENOTSUP;
 	async_answer_0(callid, ret);
@@ -834,5 +837,5 @@
 	const pcm_sample_format_t format = DEV_IPC_GET_ARG3(*call) & UINT16_MAX;
 
-	const errno_t ret = pcm_iface->start_capture
+	const int ret = pcm_iface->start_capture
 	    ? pcm_iface->start_capture(fun, frames, channels, rate, format)
 	    : ENOTSUP;
@@ -846,5 +849,5 @@
 	const bool immediate = DEV_IPC_GET_ARG1(*call);
 
-	const errno_t ret = pcm_iface->stop_capture ?
+	const int ret = pcm_iface->stop_capture ?
 	    pcm_iface->stop_capture(fun, immediate) : ENOTSUP;
 	async_answer_0(callid, ret);
